<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Rate limiter &mdash; Heiwa  documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
      <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/jquery.js"></script>
        <script src="_static/underscore.js"></script>
        <script src="_static/doctools.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Tasks" href="heiwa.tasks.html" />
    <link rel="prev" title="Exceptions" href="heiwa.exceptions.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="index.html" class="icon icon-home"> Heiwa
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="performance.html">Performance</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="heiwa.html">API Documentation</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="heiwa.html#subpackages">Subpackages</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="heiwa.authentication.html">Authentication</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.constants.html">Statuses</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.database.html">Database</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.json_ld.html">JSON-LD</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.enums.html">Enums</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.error_handlers.html">Error handlers</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.exceptions.html">Exceptions</a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">Rate limiter</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.tasks.html">Tasks</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.types.html">Abstract types</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.validators.html">Validators</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.html">API views</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.html#module-heiwa">Root</a></li>
</ul>
</li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">Heiwa</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="heiwa.html">API Documentation</a> &raquo;</li>
      <li>Rate limiter</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/heiwa.limiter.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="module-heiwa.limiter">
<span id="rate-limiter"></span><h1>Rate limiter<a class="headerlink" href="#module-heiwa.limiter" title="Permalink to this headline"></a></h1>
<p>Rate limiting.</p>
<dl class="py class">
<dt class="sig sig-object py" id="heiwa.limiter.Limiter">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">heiwa.limiter.</span></span><span class="sig-name descname"><span class="pre">Limiter</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">default_limits:</span> <span class="pre">typing.Union[None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">typing.Iterable[str]]</span> <span class="pre">=</span> <span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">endpoint_limits:</span> <span class="pre">typing.Union[None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">typing.Dict[str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">typing.Iterable[str]]]</span> <span class="pre">=</span> <span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">storage_class:</span> <span class="pre">limits.storage.base.Storage</span> <span class="pre">=</span> <span class="pre">&lt;class</span> <span class="pre">'limits.storage.memory.MemoryStorage'&gt;</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">strategy_class:</span> <span class="pre">limits.strategies.RateLimiter</span> <span class="pre">=</span> <span class="pre">&lt;class</span> <span class="pre">'limits.strategies.MovingWindowRateLimiter'&gt;</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">key_func:</span> <span class="pre">typing.Callable[[]</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">typing.Hashable]</span> <span class="pre">=</span> <span class="pre">&lt;function</span> <span class="pre">Limiter.&lt;lambda&gt;&gt;</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">endpoint_func:</span> <span class="pre">typing.Callable[[]</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">str]</span> <span class="pre">=</span> <span class="pre">&lt;function</span> <span class="pre">Limiter.&lt;lambda&gt;&gt;</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/heiwa/limiter.html#Limiter"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.limiter.Limiter" title="Permalink to this definition"></a></dt>
<dd><p>Rate limiter, primarily compatible with Flask applications.</p>
<dl class="py method">
<dt class="sig sig-object py" id="heiwa.limiter.Limiter.__init__">
<span class="sig-name descname"><span class="pre">__init__</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">default_limits:</span> <span class="pre">typing.Union[None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">typing.Iterable[str]]</span> <span class="pre">=</span> <span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">endpoint_limits:</span> <span class="pre">typing.Union[None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">typing.Dict[str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">typing.Iterable[str]]]</span> <span class="pre">=</span> <span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">storage_class:</span> <span class="pre">limits.storage.base.Storage</span> <span class="pre">=</span> <span class="pre">&lt;class</span> <span class="pre">'limits.storage.memory.MemoryStorage'&gt;</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">strategy_class:</span> <span class="pre">limits.strategies.RateLimiter</span> <span class="pre">=</span> <span class="pre">&lt;class</span> <span class="pre">'limits.strategies.MovingWindowRateLimiter'&gt;</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">key_func:</span> <span class="pre">typing.Callable[[]</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">typing.Hashable]</span> <span class="pre">=</span> <span class="pre">&lt;function</span> <span class="pre">Limiter.&lt;lambda&gt;&gt;</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">endpoint_func:</span> <span class="pre">typing.Callable[[]</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">str]</span> <span class="pre">=</span> <span class="pre">&lt;function</span> <span class="pre">Limiter.&lt;lambda&gt;&gt;</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="reference internal" href="_modules/heiwa/limiter.html#Limiter.__init__"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.limiter.Limiter.__init__" title="Permalink to this definition"></a></dt>
<dd><p>Sets this instance’s attributes to the given values.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>default_limits</strong> – An iterable of default rate limits. For example,
<code class="docutils literal notranslate"><span class="pre">4/1second</span></code> and <code class="docutils literal notranslate"><span class="pre">2000/1hour</span></code>. If this value is <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code> and
this method is running within a Flask app context, it’s set to the
app’s <code class="docutils literal notranslate"><span class="pre">RATELIMIT_DEFAULT</span></code> config key, if there is one.</p></li>
<li><p><strong>endpoint_limits</strong> – The same as <code class="docutils literal notranslate"><span class="pre">default_limits</span></code>, but for specific
endpoints, where the key corresponds to the endpoint’s name.</p></li>
<li><p><strong>storage_class</strong> – The storage backend this rate limiter uses to store
requests.</p></li>
<li><p><strong>strategy_class</strong> – The strategy for this rate limiter.</p></li>
<li><p><strong>key_func</strong> – A function that returns the unique identifier for the
current user with each request. By default, this will be remote IP
addresses.</p></li>
<li><p><strong>endpoint_func</strong> – A function which returns the current endpoint with
each request. By default, this will be <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.request.endpoint</span></code>.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="heiwa.limiter.Limiter.__weakref__">
<span class="sig-name descname"><span class="pre">__weakref__</span></span><a class="headerlink" href="#heiwa.limiter.Limiter.__weakref__" title="Permalink to this definition"></a></dt>
<dd><p>list of weak references to the object (if defined)</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="heiwa.limiter.Limiter.check">
<span class="sig-name descname"><span class="pre">check</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">identifier</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">Hashable</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">endpoint</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">str</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">add_expires</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">bool</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">bool</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">bool</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">datetime.datetime</span><span class="p"><span class="pre">]</span></span><span class="p"><span class="pre">]</span></span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/limiter.html#Limiter.check"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.limiter.Limiter.check" title="Permalink to this definition"></a></dt>
<dd><p>Gets whether or not the current user has exceeded the rate limit for
the given endpoint.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>identifier</strong> – The current user’s identifier. If <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>, the
output of the <code class="xref py py-attr docutils literal notranslate"><span class="pre">key_func</span></code> is used. This
is generally expected behavior.</p></li>
<li><p><strong>endpoint</strong> – The current endpoint.</p></li>
<li><p><strong>add_expires</strong> – Whether or not the function should return the time the
user will be allowed to access the endpoint again. If <code class="xref py py-data docutils literal notranslate"><span class="pre">True</span></code>,
this will always be returned, even if they have not exceeded the rate
limit.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>If <code class="docutils literal notranslate"><span class="pre">add_expires</span></code> is <code class="xref py py-data docutils literal notranslate"><span class="pre">False</span></code>, whether or not the user
has exceeded the rate limit, stored in a boolean value. If it’s
<code class="xref py py-data docutils literal notranslate"><span class="pre">True</span></code>, that value and also the time they can access it again.</p>
</dd>
</dl>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>If there are no rate limits specified for the current endpoint, it’s
assumed that it has none. For example, when a rate limit specific to
the endpoint is an empty iterable, the default limit is overriden
and the endpoint has no rate limit at all.</p>
</div>
</dd></dl>

</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.limiter.init_limiter">
<span class="sig-prename descclassname"><span class="pre">heiwa.limiter.</span></span><span class="sig-name descname"><span class="pre">init_limiter</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">app</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">flask.app.Flask</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">key_func</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Callable</span><span class="p"><span class="pre">[</span></span><span class="p"><span class="pre">[</span></span><span class="p"><span class="pre">]</span></span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">Hashable</span><span class="p"><span class="pre">]</span></span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="reference internal" href="_modules/heiwa/limiter.html#init_limiter"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.limiter.init_limiter" title="Permalink to this definition"></a></dt>
<dd><p>Instantiates a <a class="reference internal" href="#heiwa.limiter.Limiter" title="heiwa.limiter.Limiter"><code class="xref py py-class docutils literal notranslate"><span class="pre">Limiter</span></code></a> at <code class="docutils literal notranslate"><span class="pre">app.limiter</span></code>. The <code class="docutils literal notranslate"><span class="pre">key_func</span></code>
argument is taken from this function’s.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>app</strong> – The <code class="xref py py-class docutils literal notranslate"><span class="pre">Flask</span></code> app to add the rate limiter to.</p></li>
<li><p><strong>key_func</strong> – A callable object that returns the current user’s identifier.
This should always be unique for every user.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.limiter.rate_limited">
<span class="sig-prename descclassname"><span class="pre">heiwa.limiter.</span></span><span class="sig-name descname"><span class="pre">rate_limited</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">func</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Callable</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Callable</span></span></span><a class="reference internal" href="_modules/heiwa/limiter.html#rate_limited"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.limiter.rate_limited" title="Permalink to this definition"></a></dt>
<dd><p>Rate limits the decorated function, using the current Flask app’s
<code class="docutils literal notranslate"><span class="pre">limiter</span></code> attribute.</p>
<dl class="field-list simple">
<dt class="field-odd">Raises</dt>
<dd class="field-odd"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIRateLimitExceeded" title="heiwa.exceptions.APIRateLimitExceeded"><strong>heiwa.exceptions.APIRateLimitExceeded</strong></a> – Raised when the user with the
current identifier has exceeded the rate limit for the current endpoint.</p>
</dd>
</dl>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><a class="reference internal" href="#heiwa.limiter.Limiter" title="heiwa.limiter.Limiter"><code class="xref py py-class docutils literal notranslate"><span class="pre">Limiter</span></code></a></p>
</div>
</dd></dl>

</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="heiwa.exceptions.html" class="btn btn-neutral float-left" title="Exceptions" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="heiwa.tasks.html" class="btn btn-neutral float-right" title="Tasks" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p></p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>